Index: branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/GradientChart.cs
===================================================================
--- branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/GradientChart.cs	(revision 14006)
+++ branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/GradientChart.cs	(revision 14014)
@@ -48,4 +48,14 @@
 
     #region Properties
+    public string XAxisTitle {
+      get { return chart.ChartAreas[0].AxisX.Title; }
+      set { chart.ChartAreas[0].AxisX.Title = value; }
+    }
+
+    public string YAxisTitle {
+      get { return chart.ChartAreas[0].AxisY.Title; }
+      set { chart.ChartAreas[0].AxisY.Title = value; }
+    }
+
     public bool ShowLegend {
       get { return chart.Legends[0].Enabled; }
@@ -218,5 +228,4 @@
       chart.ContextMenuStrip.Items.Add(new ToolStripSeparator());
       chart.ContextMenuStrip.Items.Add(configToolStripMenuItem);
-
       configurationDialog = new GradientChartConfigurationDialog(this);
 
Index: branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/RegressionSolutionGradientView.cs
===================================================================
--- branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/RegressionSolutionGradientView.cs	(revision 14006)
+++ branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/RegressionSolutionGradientView.cs	(revision 14014)
@@ -25,8 +25,8 @@
 using System.Windows.Forms;
 using HeuristicLab.Collections;
+using HeuristicLab.Core.Views;
 using HeuristicLab.MainForm;
 using HeuristicLab.MainForm.WindowsForms;
 using HeuristicLab.Problems.DataAnalysis;
-using HeuristicLab.Problems.DataAnalysis.Views;
 using HeuristicLab.Visualization.ChartControlsExtensions;
 
@@ -34,5 +34,5 @@
   [View("Gradient View")]
   [Content(typeof(IRegressionSolution))]
-  public partial class RegressionSolutionGradientView : DataAnalysisSolutionEvaluationView {
+  public partial class RegressionSolutionGradientView : ItemView {
     private const int DrawingSteps = 1000;
 
Index: branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/RegressionSolutionTargetResponseGradientView.Designer.cs
===================================================================
--- branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/RegressionSolutionTargetResponseGradientView.Designer.cs	(revision 14006)
+++ branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/RegressionSolutionTargetResponseGradientView.Designer.cs	(revision 14014)
@@ -31,10 +31,10 @@
       this.automaticYAxisCheckBox = new System.Windows.Forms.CheckBox();
       this.densityGroupBox = new System.Windows.Forms.GroupBox();
+      this.columnsTextBox = new System.Windows.Forms.TextBox();
+      this.columnsLabel = new System.Windows.Forms.Label();
       this.densityComboBox = new System.Windows.Forms.ComboBox();
+      this.label1 = new System.Windows.Forms.Label();
       this.configSplitContainer = new System.Windows.Forms.SplitContainer();
       this.variableGroupBox = new System.Windows.Forms.GroupBox();
-      this.layoutGroupBox = new System.Windows.Forms.GroupBox();
-      this.columnsTextBox = new System.Windows.Forms.TextBox();
-      this.columnsLabel = new System.Windows.Forms.Label();
       this.scrollPanel = new System.Windows.Forms.Panel();
       this.errorProvider = new System.Windows.Forms.ErrorProvider(this.components);
@@ -46,5 +46,4 @@
       this.configSplitContainer.SuspendLayout();
       this.variableGroupBox.SuspendLayout();
-      this.layoutGroupBox.SuspendLayout();
       this.scrollPanel.SuspendLayout();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
@@ -57,5 +56,5 @@
       this.variableListView.Location = new System.Drawing.Point(3, 16);
       this.variableListView.Name = "variableListView";
-      this.variableListView.Size = new System.Drawing.Size(163, 458);
+      this.variableListView.Size = new System.Drawing.Size(163, 478);
       this.variableListView.TabIndex = 0;
       this.variableListView.UseCompatibleStateImageBehavior = false;
@@ -113,12 +112,35 @@
       // densityGroupBox
       // 
+      this.densityGroupBox.Controls.Add(this.columnsTextBox);
+      this.densityGroupBox.Controls.Add(this.columnsLabel);
       this.densityGroupBox.Controls.Add(this.densityComboBox);
+      this.densityGroupBox.Controls.Add(this.label1);
       this.densityGroupBox.Dock = System.Windows.Forms.DockStyle.Top;
       this.densityGroupBox.Location = new System.Drawing.Point(0, 77);
       this.densityGroupBox.Name = "densityGroupBox";
-      this.densityGroupBox.Size = new System.Drawing.Size(169, 49);
+      this.densityGroupBox.Size = new System.Drawing.Size(169, 74);
       this.densityGroupBox.TabIndex = 3;
       this.densityGroupBox.TabStop = false;
-      this.densityGroupBox.Text = "Density";
+      this.densityGroupBox.Text = "Settings";
+      // 
+      // columnsTextBox
+      // 
+      this.columnsTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.columnsTextBox.Location = new System.Drawing.Point(66, 46);
+      this.columnsTextBox.Name = "columnsTextBox";
+      this.columnsTextBox.Size = new System.Drawing.Size(94, 20);
+      this.columnsTextBox.TabIndex = 1;
+      this.columnsTextBox.Validating += new System.ComponentModel.CancelEventHandler(this.columnsTextBox_Validating);
+      this.columnsTextBox.Validated += new System.EventHandler(this.columnsTextBox_Validated);
+      // 
+      // columnsLabel
+      // 
+      this.columnsLabel.AutoSize = true;
+      this.columnsLabel.Location = new System.Drawing.Point(7, 49);
+      this.columnsLabel.Name = "columnsLabel";
+      this.columnsLabel.Size = new System.Drawing.Size(50, 13);
+      this.columnsLabel.TabIndex = 0;
+      this.columnsLabel.Text = "Columns:";
       // 
       // densityComboBox
@@ -133,9 +155,18 @@
             "Test",
             "All"});
-      this.densityComboBox.Location = new System.Drawing.Point(6, 19);
+      this.densityComboBox.Location = new System.Drawing.Point(66, 19);
       this.densityComboBox.Name = "densityComboBox";
-      this.densityComboBox.Size = new System.Drawing.Size(157, 21);
+      this.densityComboBox.Size = new System.Drawing.Size(94, 21);
       this.densityComboBox.TabIndex = 0;
       this.densityComboBox.SelectedIndexChanged += new System.EventHandler(this.densityComboBox_SelectedIndexChanged);
+      // 
+      // label1
+      // 
+      this.label1.AutoSize = true;
+      this.label1.Location = new System.Drawing.Point(7, 22);
+      this.label1.Name = "label1";
+      this.label1.Size = new System.Drawing.Size(45, 13);
+      this.label1.TabIndex = 0;
+      this.label1.Text = "Density:";
       // 
       // configSplitContainer
@@ -149,5 +180,4 @@
       // 
       this.configSplitContainer.Panel1.Controls.Add(this.variableGroupBox);
-      this.configSplitContainer.Panel1.Controls.Add(this.layoutGroupBox);
       this.configSplitContainer.Panel1.Controls.Add(this.densityGroupBox);
       this.configSplitContainer.Panel1.Controls.Add(this.yAxisConfigGroupBox);
@@ -159,4 +189,5 @@
       this.configSplitContainer.SplitterDistance = 169;
       this.configSplitContainer.TabIndex = 0;
+      this.configSplitContainer.TabStop = false;
       // 
       // variableGroupBox
@@ -164,42 +195,10 @@
       this.variableGroupBox.Controls.Add(this.variableListView);
       this.variableGroupBox.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.variableGroupBox.Location = new System.Drawing.Point(0, 171);
+      this.variableGroupBox.Location = new System.Drawing.Point(0, 151);
       this.variableGroupBox.Name = "variableGroupBox";
-      this.variableGroupBox.Size = new System.Drawing.Size(169, 477);
+      this.variableGroupBox.Size = new System.Drawing.Size(169, 497);
       this.variableGroupBox.TabIndex = 1;
       this.variableGroupBox.TabStop = false;
       this.variableGroupBox.Text = "Variables";
-      // 
-      // layoutGroupBox
-      // 
-      this.layoutGroupBox.Controls.Add(this.columnsTextBox);
-      this.layoutGroupBox.Controls.Add(this.columnsLabel);
-      this.layoutGroupBox.Dock = System.Windows.Forms.DockStyle.Top;
-      this.layoutGroupBox.Location = new System.Drawing.Point(0, 126);
-      this.layoutGroupBox.Name = "layoutGroupBox";
-      this.layoutGroupBox.Size = new System.Drawing.Size(169, 45);
-      this.layoutGroupBox.TabIndex = 5;
-      this.layoutGroupBox.TabStop = false;
-      this.layoutGroupBox.Text = "Layout";
-      // 
-      // columnsTextBox
-      // 
-      this.columnsTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.columnsTextBox.Location = new System.Drawing.Point(66, 17);
-      this.columnsTextBox.Name = "columnsTextBox";
-      this.columnsTextBox.Size = new System.Drawing.Size(94, 20);
-      this.columnsTextBox.TabIndex = 1;
-      this.columnsTextBox.Validating += new System.ComponentModel.CancelEventHandler(this.columnsTextBox_Validating);
-      this.columnsTextBox.Validated += new System.EventHandler(this.columnsTextBox_Validated);
-      // 
-      // columnsLabel
-      // 
-      this.columnsLabel.AutoSize = true;
-      this.columnsLabel.Location = new System.Drawing.Point(7, 20);
-      this.columnsLabel.Name = "columnsLabel";
-      this.columnsLabel.Size = new System.Drawing.Size(50, 13);
-      this.columnsLabel.TabIndex = 0;
-      this.columnsLabel.Text = "Columns:";
       // 
       // scrollPanel
@@ -227,4 +226,5 @@
       this.yAxisConfigGroupBox.PerformLayout();
       this.densityGroupBox.ResumeLayout(false);
+      this.densityGroupBox.PerformLayout();
       this.configSplitContainer.Panel1.ResumeLayout(false);
       this.configSplitContainer.Panel2.ResumeLayout(false);
@@ -232,6 +232,4 @@
       this.configSplitContainer.ResumeLayout(false);
       this.variableGroupBox.ResumeLayout(false);
-      this.layoutGroupBox.ResumeLayout(false);
-      this.layoutGroupBox.PerformLayout();
       this.scrollPanel.ResumeLayout(false);
       this.scrollPanel.PerformLayout();
@@ -253,8 +251,8 @@
     private System.Windows.Forms.GroupBox variableGroupBox;
     private System.Windows.Forms.Panel scrollPanel;
-    private System.Windows.Forms.GroupBox layoutGroupBox;
     private System.Windows.Forms.TextBox columnsTextBox;
     private System.Windows.Forms.Label columnsLabel;
     private System.Windows.Forms.ErrorProvider errorProvider;
+    private System.Windows.Forms.Label label1;
   }
 }
Index: branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/RegressionSolutionTargetResponseGradientView.cs
===================================================================
--- branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/RegressionSolutionTargetResponseGradientView.cs	(revision 14006)
+++ branches/HeuristicLab.RegressionSolutionGradientView/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/RegressionSolutionTargetResponseGradientView.cs	(revision 14014)
@@ -31,5 +31,5 @@
 
 namespace HeuristicLab.Problems.DataAnalysis.Views {
-  [View("Target Response Gradient View")]
+  [View("Target Response Gradients")]
   [Content(typeof(IRegressionSolution))]
   public partial class RegressionSolutionTargetResponseGradientView : DataAnalysisSolutionEvaluationView {
@@ -209,7 +209,15 @@
       tl.Controls.Clear();
       int row = 0, column = 0;
-      foreach (var chartsPanel in VisibleChartsPanels) {
+      foreach (var v in VisibleVariables) {
+        var chartsPanel = groupingPanels[v];
         tl.Controls.Add(chartsPanel, column, row);
+
+        if (column == 0) {
+          var chart = gradientCharts[v];
+          chart.YAxisTitle = Content.ProblemData.TargetVariable;
+        }
+
         column++;
+
         if (column == MaxColumns) {
           row++;
@@ -361,5 +369,5 @@
         ReOrderControls();
         SetStyles();
-        tl.ResumeLayout();
+        tl.ResumeLayout(true);
       }
     }